// Eva.cpp : main source file for Eva.exe
//

#include "stdafx.h"

#include "resource.h"

#include "EvaView.h"
#include "aboutdlg.h"
#include "MainFrm.h"

CAppModule _Module;
CMainFrame wndMain;

int Run(LPTSTR /*lpstrCmdLine*/ = NULL, int nCmdShow = SW_SHOWNORMAL)
{
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

#if !defined(_WIN32_WCE)
	RECT initialSize = { CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT+472, CW_USEDEFAULT+512};
	if(wndMain.CreateEx(NULL, &initialSize) == NULL)
#else
	RECT initialSize = { 0, 0, CW_USEDEFAULT, CW_USEDEFAULT};
	if(wndMain.CreateEx(NULL, initialSize, WS_VISIBLE) == NULL)
#endif
	{
		ATLTRACE(_T("Main window creation failed!\n"));
		return 0;
	}

	wndMain.ShowWindow(nCmdShow);

	int nRet = theLoop.Run();

	_Module.RemoveMessageLoop();
	return nRet;
}

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE /*hPrevInstance*/, LPTSTR lpstrCmdLine, int nCmdShow)
{
	HRESULT hRes;
#if defined(_WIN32_WCE)
	hRes = CMainFrame::ActivatePreviousInstance(hInstance);
	if(FAILED(hRes) || S_FALSE == hRes)
	{
		return hRes;
	}
#endif
	// hRes = ::CoInitializeEx(NULL, COINIT_MULTITHREADED);
	// ATLASSERT(SUCCEEDED(hRes));

	/*
	Calling AtlInitCommonControls is not necessary to utilize picture,
	static text, edit box, group box, button, check box, radio button, 
	combo box, list box, or the horizontal and vertical scroll bars.

	Calling AtlInitCommonControls with 0 is required to utilize the spin, 
	progress, slider, list, tree, and tab controls.

	Adding the ICC_DATE_CLASSES flag is required to initialize the 
	date time picker and month calendar controls.

	Add additional flags to support additoinal controls not mentioned above.
	*/
#if defined(_WIN32_WCE)
	AtlInitCommonControls(ICC_DATE_CLASSES);
#else
	// this resolves ATL window thunking problem when Microsoft Layer
	// for Unicode (MSLU) is used
	::DefWindowProc(NULL, 0, 0, 0L);

	// add flags to support other controls
	AtlInitCommonControls(ICC_COOL_CLASSES | ICC_BAR_CLASSES);
#endif

	hRes = _Module.Init(NULL, hInstance);
	ATLASSERT(SUCCEEDED(hRes));

	int nRet = Run(lpstrCmdLine, nCmdShow);

	_Module.Term();
	// ::CoUninitialize();

	return nRet;
}
