// VBProgView.cpp : implementation of the CEvaView class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"
#include <assert.h>

#include "EvaView.h"
#include "MainFrm.h"
#include ".\evaview.h"

#define USE_CONFIG_TAB 0

BOOL CEvaView::PreTranslateMessage(MSG* pMsg)
{
	BOOL res = CWindow::IsDialogMessage(pMsg);

	return res;
}

LRESULT CEvaView::OnTcnSelchangeTabView(int /*idCtrl*/, LPNMHDR pNMHDR, BOOL& /*bHandled*/)
{
	int iSel = m_tabCtrl.GetCurSel();
	switch (iSel)
	{
#if USE_CONFIG_TAB
	case 0:
		m_configPage->ShowWindow(SW_SHOW);
		m_hexPage1->ShowWindow(SW_HIDE);
		m_hexPage2->ShowWindow(SW_HIDE);
		break;
	case 1:
		m_configPage->ShowWindow(SW_HIDE);
		m_hexPage1->ShowWindow(SW_SHOW);
		m_hexPage2->ShowWindow(SW_HIDE);
		break;
	case 2:
		m_configPage->ShowWindow(SW_HIDE);
		m_hexPage1->ShowWindow(SW_HIDE);
		m_hexPage2->ShowWindow(SW_SHOW);
		break;
#else
	case 0:
		m_hexPage1->ShowWindow(SW_SHOW);
		m_hexPage2->ShowWindow(SW_HIDE);
		break;
	case 1:
		m_hexPage1->ShowWindow(SW_HIDE);
		m_hexPage2->ShowWindow(SW_SHOW);
		break;
#endif
	default:
		assert(false);
	}

	return 0;
}

static int fontSizes[] = { 9, 10, 11, 12, 14, 16 };

// Create fonts for 96 & 192 DPI.
void CEvaView::createFonts()
{
	int numFonts = sizeof(fontSizes)/sizeof(fontSizes[0]);
	m_highResFonts = new CFont[numFonts];
	m_lowResFonts = new CFont[numFonts];

	int logPixelsY = GetDeviceCaps(NULL, LOGPIXELSY);
	if (logPixelsY == 0) logPixelsY = 72;
	int fontHeight = -::MulDiv(10, logPixelsY, 72); // 12;

	LOGFONT lf = { 0 };
#if !defined(_WIN32_WCE)
	lf.lfWeight = FW_BOLD;
#endif
	lf.lfPitchAndFamily = FIXED_PITCH | FF_DONTCARE; // FF_MODERN;

	for (int ctr1=0;ctr1<numFonts;ctr1++)
	{
		int iHighResPointSize = 2 * fontSizes[ctr1];
		lf.lfHeight = iHighResPointSize;
		// lf.lfHeight = -MulDiv(iHighResPointSize, logPixelsY, 72); // -(iHighResPointSize * 96) / 72;
		m_highResFonts[ctr1].CreateFontIndirect(&lf);

		int iLowResPointSize = fontSizes[ctr1];
		lf.lfHeight = iLowResPointSize; // -(iLowResPointSize * 96) / 72;
		// lf.lfHeight = -MulDiv(iLowResPointSize, logPixelsY, 72); // -(iLowResPointSize * 96) / 72;
		m_lowResFonts[ctr1].CreateFontIndirect(&lf);
	}
}

void CEvaView::uncheckAllFontSizes()
{
#if 0
	CMenu hMenu = ::GetMenu();
	if (hMenu != NULL)
	{
		// Get the pull-out menu for font sizes (TBD: change to combo box?)
		hMenu.CheckMenuItem(ID_FONT_SIZE_9, MF_UNCHECKED);
		hMenu.CheckMenuItem(ID_FONT_SIZE_10, MF_UNCHECKED);
		hMenu.CheckMenuItem(ID_FONT_SIZE_11, MF_UNCHECKED);
		hMenu.CheckMenuItem(ID_FONT_SIZE_12, MF_UNCHECKED);
		hMenu.CheckMenuItem(ID_FONT_SIZE_16, MF_UNCHECKED);
	}
#endif
}

void CEvaView::checkMenuItem(int itemID)
{
#if 0
	CMenu hMenu = GetMenu();
	if (hMenu != NULL)
	{
		hMenu.CheckMenuItem(itemID, MF_CHECKED);
	}
#endif
}

LRESULT CEvaView::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
#if 1
	createFonts();
#if defined(_WIN32_WCE)
	m_fontIndex  = 2;
	m_charHeight = 12;
	checkMenuItem(ID_FONT_SIZE_11);
#else
	m_fontIndex  = 4;
	m_charHeight = 12;
	checkMenuItem(ID_FONT_SIZE_14);
#endif
#else
#if defined(_WIN32_WCE)
	LOGFONT lf = { 0 };
	// lf.lfWeight = FW_BOLD;
	lf.lfPitchAndFamily = FIXED_PITCH | FF_MODERN;
	int logPixelsY = GetDeviceCaps(NULL, LOGPIXELSY);
	int fontHeight = 
	HDC screenDC = GetDC(NULL);

	lf.lfHeight = -MulDiv(10, logPixelsY, 72); // 12;
	m_textFontLow.CreateFontIndirect(&lf);
	lf.lfHeight = 22;
	m_textFontHigh.CreateFontIndirect(&lf);
#else
	m_textFontLow.CreateFont(-12, 0, 0, 0, FW_BOLD,
		FALSE, FALSE, FALSE, ANSI_CHARSET, OUT_DEFAULT_PRECIS, CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY, FIXED_PITCH | FF_DONTCARE, NULL); // _T("Courier New"));
#endif
#endif

	m_tabCtrl.Attach(GetDlgItem(IDC_TAB_VIEW));
	m_tabCtrl.SetParent(m_hWnd);

	m_hexPage1 = new ChexPageDlg(); 
	m_hexPage2 = new ChexPageDlg(); 
#if USE_CONFIG_TAB
	m_configPage = new CconfigPageDlg(); 
#endif

	RECT cRect, wRect;

	this->GetClientRect(&cRect);
	cRect.bottom -= 40; // TBD: resize
	m_tabCtrl.MoveWindow(&cRect);

	// Determine the available space within the tab control
	m_tabCtrl.GetClientRect(&cRect);
	m_tabCtrl.GetWindowRect(&wRect);
	RECT dRect = wRect;
	TabCtrl_AdjustRect(m_tabCtrl.m_hWnd, FALSE, &dRect);

	// Create and size the contents of the tab pages.  The tab
	// control will be the parent of the contents
	m_hexPage1->Create(m_tabCtrl.m_hWnd, dRect);
	m_hexPage2->Create(m_tabCtrl.m_hWnd, dRect);
#if USE_CONFIG_TAB
	m_configPage->Create(m_tabCtrl.m_hWnd, dRect);
#endif

	// Add tabs to the tab control
	TCITEM item;
	item.mask = TCIF_TEXT;
#if USE_CONFIG_TAB
	item.pszText = _T("Config");
	m_tabCtrl.InsertItem(0, &item);
	item.pszText = _T("Hex 1");
	m_tabCtrl.InsertItem(1, &item);
	item.pszText = _T("Hex 2");
	m_tabCtrl.InsertItem(2, &item);
#else
	item.pszText = _T("Hex 1");
	m_tabCtrl.InsertItem(0, &item);
	item.pszText = _T("Hex 2");
	m_tabCtrl.InsertItem(1, &item);
#endif

	m_hexPage1->m_hexPanel.SetFont(m_lowResFonts[m_fontIndex]);
	m_hexPage1->m_dataPanel.SetFont(m_lowResFonts[m_fontIndex]);
	m_hexPage1->SetCtrlFont(m_lowResFonts[m_fontIndex]);

	m_hexPage2->m_hexPanel.SetFont(m_lowResFonts[m_fontIndex]);
	m_hexPage2->m_dataPanel.SetFont(m_lowResFonts[m_fontIndex]);
	m_hexPage2->SetCtrlFont(m_lowResFonts[m_fontIndex]);

	// Show the config page and hide the others
#if USE_CONFIG_TAB
	m_configPage->ShowWindow(SW_HIDE);
#endif
	m_hexPage1->ShowWindow(SW_SHOW);
	m_hexPage2->ShowWindow(SW_HIDE);

	return TRUE;
}

LRESULT CEvaView::OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& /*bHandled*/)
{
	int width = LOWORD(lParam);
	int height = HIWORD(lParam);

#if defined(_WIN32_WCE)
	m_inHighRes = (width > 320 || height > 320);
#else
	m_inHighRes = false;
#endif

#if 0
	// Get the size of the font in the group box
	CFont *grpFnt = m_asmSourceGroupBox.GetFont();
	LOGFONT lf;
	int res = grpFnt->GetLogFont(&lf);
	if (res != 0)
		m_charHeight = 4 + -lf.lfHeight;
	else
	{
		if (m_inHighRes)
			m_charHeight = 26;
		else
			m_charHeight = 13;
	}
#endif

	// If high res, then use high res font
	if (m_inHighRes)
	{
		m_hexPage1->SetCtrlFont(m_highResFonts[m_fontIndex]);
		m_hexPage1->m_inHighRes = true;
		m_hexPage2->SetCtrlFont(m_highResFonts[m_fontIndex]);
		m_hexPage2->m_inHighRes = true;
	}
	else
	{
		m_inHighRes = false;
		m_hexPage1->SetCtrlFont(m_lowResFonts[m_fontIndex]);
		m_hexPage1->m_inHighRes = false;
		m_hexPage2->SetCtrlFont(m_lowResFonts[m_fontIndex]);
		m_hexPage2->m_inHighRes = false;
	}

	if (m_tabCtrl.m_hWnd != NULL)
	{
		RECT cRect;
		// Resize the tab control to fill the client area of the form
		GetClientRect(&cRect);
		m_tabCtrl.MoveWindow(&cRect);

		// Get the size of the rectangle within the tab page that we can
		// use to display individual pages.
		m_tabCtrl.GetClientRect(&cRect);
		TabCtrl_AdjustRect(m_tabCtrl.m_hWnd, FALSE, &cRect);

		// Resize the page contents to fit the tab control.
		m_hexPage1->MoveWindow(&cRect);
		m_hexPage2->MoveWindow(&cRect);
#if USE_CONFIG_TAB
		m_configPage->MoveWindow(&cRect);
#endif
	}

	return 0;
}
