#include "StdAfx.h"
#include "resource.h"
#include "MainFrm.h"
#include "HexCodePanel.h"
#include ".\hexcodepanel.h"

extern CMainFrame wndMain;

CHexCodePanel::CHexCodePanel(void)
{
	mCodeDisplay = false;
	mMenuID = IDR_DISASM;
	mParentWnd = NULL;
}

CHexCodePanel::~CHexCodePanel(void)
{
}


void CHexCodePanel::ContextMenu(int x, int y)
{
    CMenu mnuCtxt;
    CMenuHandle pMenu;
	CPoint point(x, y);
	
    if (!mMenuID)
        return;
	
    if(mnuCtxt.LoadMenu(mMenuID))
    {
        pMenu = mnuCtxt.GetSubMenu(0);
		
		// Show and track the popup
        if(pMenu)
        {
			if (mCodeDisplay)
			{
				pMenu.EnableMenuItem(ID_VIEW_ASM, MF_GRAYED);
				pMenu.EnableMenuItem(ID_VIEW_HEX, MF_ENABLED);
			}
			else
			{
				pMenu.EnableMenuItem(ID_VIEW_ASM, MF_ENABLED);
				pMenu.EnableMenuItem(ID_VIEW_HEX, MF_GRAYED);
			}
			
			mMenuPt = point;
            // ClientToScreen(&point);
			pMenu.TrackPopupMenu(TPM_LEFTALIGN, point.x, point.y, m_hWnd);
        }
    }
}


LRESULT CHexCodePanel::OnContextMenu(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	ContextMenu(GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam));

	return 0;
}

LRESULT CHexCodePanel::OnEraseBkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// TODO: Add your message handler code here and/or call default

	return 0;
}

LRESULT CHexCodePanel::OnLButtonDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM lParam, BOOL& bHandled)
{
#if defined(_WIN32_WCE)
	CPoint point(GET_X_LPARAM(lParam), GET_Y_LPARAM(lParam));
	SHRGINFO shrgi = {0};
	
    shrgi.cbSize        = sizeof(SHRGINFO);
    shrgi.hwndClient    = m_hWnd;
    shrgi.ptDown.x      = point.x;
    shrgi.ptDown.y      = point.y;
    shrgi.dwFlags       = SHRG_RETURNCMD;
	
    if(GN_CONTEXTMENU == ::SHRecognizeGesture(&shrgi))
	{
        // ContextMenu(point.x, point.y);
		bHandled = FALSE;
		return 0;
	}
#endif

	bHandled = FALSE;
	return 0;
}

LRESULT CHexCodePanel::OnLButtonDblClk(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	// TODO: Add your message handler code here and/or call default

	bHandled = FALSE;
	return 0;
}

LRESULT CHexCodePanel::OnLButtonUp(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled)
{
	// TODO: Add your message handler code here and/or call default

	bHandled = FALSE;
	return 0;
}

LRESULT CHexCodePanel::OnViewAsm(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// The main app should handle this - it's not appropriate to do it
	// within a GUI control.
	return wndMain.OnViewAsm(wNotifyCode, wID, hWndCtl, bHandled);
}

LRESULT CHexCodePanel::OnViewHex(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	// The main app should handle this - it's not appropriate to do it
	// within a GUI control.
	return wndMain.OnViewHex(wNotifyCode, wID, hWndCtl, bHandled);
}
