#include "StdAfx.h"
#include "resource.h"
#include "OptionsDlg.h"

COptionsDlg::COptionsDlg(CDefaultsManager *evaDefaults)
{
	defaults = evaDefaults;
}

LRESULT COptionsDlg::OnInitDialog(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	// Align everything
	CenterWindow(GetParent());

	// Attach member controls
	baudRateCombo.Attach(GetDlgItem(IDC_BAUDRATE_COMBO));
	asmViewCombo.Attach(GetDlgItem(IDC_ASMVIEW_COMBO));

	// Set dialog items based on member values
	if (defaults == NULL)
	{
		int index;
		baudRateCombo.InsertString(0, _T("38200"));
		baudRateCombo.InsertString(1, _T("115200"));
		index = asmViewCombo.InsertString(0, _T("Assembly Only"));
		asmViewCombo.SetItemData(index, 0);
		index = asmViewCombo.InsertString(1, _T("Addresses"));
		asmViewCombo.SetItemData(index, 1);
	}
	else
	{
		// Set baud rates
		TCHAR intStr[16];
		defaultsIntList &baudRates = defaults->getAllowedBaudRates();
		defaultsIntList::iterator baudItr;
		int index = 0;
		for (baudItr=baudRates.begin();baudItr!=baudRates.end();baudItr++)
		{
			_stprintf(intStr, _T("%d"), *baudItr);
			baudRateCombo.InsertString(index++, intStr);
		}
		// Set labels
		defaultsLabelList &viewLabels = defaults->getAllowedAsmViewLabels();
		defaultsIntList &viewVals = defaults->getAllowedAsmViews();
		defaultsLabelList::iterator labItr;
		defaultsIntList::iterator valItr;
		index = 0;
		for (labItr=viewLabels.begin(),valItr=viewVals.begin();
			labItr!=viewLabels.end() && valItr!=viewVals.end();
			labItr++,valItr++)
		{
			asmViewCombo.InsertString(index++, *labItr);
			asmViewCombo.SetItemData(index, *valItr);
		}
	}

	// Select the combo item corresponding to the current value
	baudRateCombo.SetCurSel(0); // TBD: set to correct value
	asmViewCombo.SetCurSel(0);

	// CDefaultsManager m_Defaults;


	return TRUE;
}

LRESULT COptionsDlg::OnCloseCmd(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// Copy item values to members

	// Tell Windows we want the dialog to close
	EndDialog(wID);

	return 0;
}
