// ProgressDlg.cpp : Implementation of CProgressDlg

#include "stdafx.h"
#include "ProgressDlg.h"

// Implementation of ProgrammerProgressIF
void CProgressDlg::InitProgress(TCHAR *statusText)
{
	if (!IsWindow())
		return;

	SendMessage(WM_EVA_PROGRESS_STRING_SET, (WPARAM)statusText, 0);
	SendMessage(WM_EVA_PROGRESS_UPDATE, 0, 0);
}

bool CProgressDlg::UpdateProgress(int addr, int maxAddr)
{
	int newPercentDone = (int)(100.0f * (float)addr / (float)maxAddr);
	if (!IsWindow())
		return FALSE;
	if (newPercentDone != m_percentDone)
	{
		m_percentDone = newPercentDone;
		SendMessage(WM_EVA_PROGRESS_UPDATE, m_percentDone, 0);
	}

	return !IsCanceled();
}

void CProgressDlg::Cancel()
{
	m_requestCancel = true;
}

bool CProgressDlg::IsCanceled()
{
	return m_requestCancel;
}

// CProgressDlg
LRESULT CProgressDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CenterWindow(GetParent());

	m_requestCancel = false;
	m_percentDone = 0;

	return 1;  // Let the system set the focus
}

LRESULT CProgressDlg::OnBnClickedCancel(WORD /*wNotifyCode*/, WORD wID, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	// TODO: Add your control notification handler code here
	m_requestCancel = true;

	EndDialog(wID);

	return 0;
}

// We get this message when there's a change in the progress bar.
LRESULT CProgressDlg::OnProgressUpdate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CProgressBarCtrl progBar = GetDlgItem(IDC_PROGRESS1);
	progBar.SetPos((int)wParam);

	UpdateWindow();

	return 1;
}


// We get this message when there's a change in the progress bar.
LRESULT CProgressDlg::OnProgressStringChange(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CStatic progText = GetDlgItem(IDC_STATUS_TEXT);
	if (wParam == NULL)
		progText.SetWindowText(_T(""));
	else
		progText.SetWindowText((TCHAR *)wParam);

	UpdateWindow();

	return 1;
}

