// ProgressDlg.h : Declaration of the CProgressDlg

#pragma once

#include "resource.h"       // main symbols
#include "PIC/ProgrammerProgressIF.h"

// CProgressDlg

class CProgressDlg : 
	public CDialogImpl<CProgressDlg>,
	public CProgrammerProgressIF
{
public:
	CProgressDlg()
	{
	}

	~CProgressDlg()
	{
	}

	enum { IDD = IDD_PROGRESSDLG };

	// Implementation of ProgrammerProgressIF
	void InitProgress(TCHAR *statusText);
	bool UpdateProgress(int addr, int maxAddr);
	void Cancel();
	bool IsCanceled();

	int errVal;

protected:
	// Used to track cancel requests
	bool m_requestCancel;
	int m_percentDone;

public:

BEGIN_MSG_MAP(CProgressDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_EVA_PROGRESS_UPDATE, OnProgressUpdate)
	MESSAGE_HANDLER(WM_EVA_PROGRESS_STRING_SET, OnProgressStringChange)
	COMMAND_HANDLER(IDCANCEL, BN_CLICKED, OnBnClickedCancel)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnBnClickedCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnProgressUpdate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnProgressStringChange(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
};


