#pragma once
#include "atlwin.h"
#include "resource.h"       // main symbols
#include "Serial/IOPort.h"

class CTesterDlg :
	public CDialogImpl<CTesterDlg>
{
public:
	CTesterDlg(CIOPort *ioPort);
	~CTesterDlg(void);
	enum { IDD = IDD_TESTERDLG };

BEGIN_MSG_MAP(CRegistersDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_CLOSE, OnClose)
	COMMAND_HANDLER(IDC_CHECK_VDD, BN_CLICKED, OnBnClickedCheckVdd)
	COMMAND_HANDLER(IDC_CHECK_VPP1, BN_CLICKED, OnBnClickedCheckVpp1)
	COMMAND_HANDLER(IDC_CHECK_VPP2, BN_CLICKED, OnBnClickedCheckVpp2)
	COMMAND_HANDLER(IDC_CHECK_PGC, BN_CLICKED, OnBnClickedCheckPgc)
	COMMAND_HANDLER(IDC_CHECK_PGD, BN_CLICKED, OnBnClickedCheckPgd)
	COMMAND_HANDLER(IDC_CHECK_PRGSEL, BN_CLICKED, OnBnClickedCheckPrgsel)
	COMMAND_HANDLER(IDC_CHECK_LED1, BN_CLICKED, OnBnClickedCheckLed1)
	COMMAND_HANDLER(IDC_CHECK_LED2, BN_CLICKED, OnBnClickedCheckLed2)
	COMMAND_HANDLER(IDC_CHECK_LED3, BN_CLICKED, OnBnClickedCheckLed3)
END_MSG_MAP()

public:
	void SetValues(unsigned char * values);

private:
	// Hold a reference to the I/O port the programmer is connected to.
	CIOPort *mPort;

	// Set the initial values of each of the checkboxes.  The bit flags should
	// be read from the programmer, otherwise the initial value may not reflect
	// the actual current value of the lines.
	// Flag positions:
	//   mFlags[0]:  0 - Vdd,  1 - Vpp1, 2 - Vpp2, 3 - CLK, 4 - DAT, 5 - PRG_SEL
	//   mFlags[1]:  0 - LED1, 1 - LED2, 2 - LED3
	unsigned char mFlags[2];

	CButton mSignalBtns[7];
	CButton mLEDBtns[4];

	// Tell the programmer to set the control lines.
	void setSignalLines();

	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnClose(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckVdd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckVpp1(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckVpp2(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckPgc(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckPgd(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckPrgsel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckLed1(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckLed2(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBnClickedCheckLed3(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
};
