// configPageDlg.cpp : Implementation of CconfigPageDlg

#include "stdafx.h"
#include "MainFrm.h"
#include "configPageDlg.h"
#include "PIC/DeviceList.h"
#include "PIC/ProgramSelector.h"

extern CMainFrame wndMain;

// CconfigPageDlg

LRESULT CconfigPageDlg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	// Connect member variables to dialog items
	m_DeviceList.Attach(GetDlgItem(IDC_COMBO_DEVICE_LIST));
	m_PortList.Attach(GetDlgItem(IDC_COMBO_PORT_LIST));
	m_testVpp.Attach(GetDlgItem(IDC_CHECK_TEST_VPP));
	m_testVdd.Attach(GetDlgItem(IDC_CHECK_TEST_VPP));
	m_testClock.Attach(GetDlgItem(IDC_CHECK_TEST_CLOCK));
	m_testData.Attach(GetDlgItem(IDC_CHECK_TEST_DATA));
	m_openButton.Attach(GetDlgItem(IDC_BUTTON_TEST_OPEN));

	// Fill in the list of known devices
	for (int i=0;DeviceList::Devices[i] != NULL;i++)
	{
		const PICDevice *device = DeviceList::Devices[i];
		m_DeviceList.AddString(device->name[2]);
	}
	// Select the default processor
	// TBD: use initialization files
	if (wndMain.m_Device != NULL)
	{
		m_DeviceList.SelectString(-1, wndMain.m_Device->name[2]);
	}
	else
	{
		m_DeviceList.SelectString(-1, _T("pic12f683"));
	}

	// Fill in the list of COM ports
	m_PortList.AddString(_T("COM1:"));
	m_PortList.AddString(_T("COM2:"));
	m_PortList.AddString(_T("COM3:"));
	m_PortList.AddString(_T("COM4:"));
	m_PortList.SetCurSel(0);

	return 1;  // Let the system set the focus
}

LRESULT CconfigPageDlg::OnCbnSelchangeComboDeviceList(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if (hWndCtl == m_DeviceList)
	{
		// If the device was changed then clear out the hex panel
		const PICDevice *device = DeviceList::Devices[m_DeviceList.GetCurSel()];
		wndMain.replaceDevice(device);
	}

	return 0;
}

LRESULT CconfigPageDlg::OnBnClickedButtonTestOpen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CIOPort &port = wndMain.m_Port;

	if (wndMain.m_Port.IsOpen())
	{
		// Close the port
		port.Close();

		m_DeviceList.EnableWindow(FALSE);
		m_PortList.EnableWindow(FALSE);
		m_testVpp.EnableWindow(FALSE);
		m_testVdd.EnableWindow(FALSE);
		m_testClock.EnableWindow(FALSE);
		m_testData.EnableWindow(FALSE);

		m_openButton.SetWindowText(_T("Open"));
	}
	else
	{
		TCHAR portName[32];
		if (SUCCEEDED(m_PortList.GetLBText(m_PortList.GetCurSel(), portName)))
		{
			port.Open(portName, CBR_38400);

			m_DeviceList.EnableWindow(TRUE);
			m_PortList.EnableWindow(TRUE);
			m_testVpp.EnableWindow(TRUE);
			m_testVdd.EnableWindow(TRUE);
			m_testClock.EnableWindow(TRUE);
			m_testData.EnableWindow(TRUE);

			m_openButton.SetWindowText(_T("Close"));
		}
	}
	// TODO: Add your control notification handler code here

	return 0;
}
