#if !defined(AFX_FILEOPENDLG1_H__5EFDF299_B718_466B_98CC_FD9C38BC6DD5__INCLUDED_)
#define AFX_FILEOPENDLG1_H__5EFDF299_B718_466B_98CC_FD9C38BC6DD5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FileOpenDlg1.h : header file
//

#include "resource.h"
#include <commdlg.h>
#include <vector>
typedef std::vector<WIN32_FIND_DATA>	CFileInfoCont;


/////////////////////////////////////////////////////////////////////////////
// CFileOpenDlg dialog

class CFileOpenDlg :
    public CDialogImpl<CFileOpenDlg>, public CUpdateUI<CFileOpenDlg>
{
	enum ViewState
	{
		vsStandard,		// Shows list and tree
		vsTreeOnly,		// Shows tree only
		vsListOnly		// Shows list only
	};

	enum {nTrackHeight = 6};

	// Construction
public:
	void AddToolButtons();
	CFileOpenDlg(
		BOOL bOpenFileDialog,
		LPCTSTR lpszDefExt = NULL,
		LPCTSTR lpszFileName = NULL,
		DWORD dwFlags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		LPCTSTR lpszFilter = NULL,
		CWindow* pParent = NULL
		);   // standard constructor
	~CFileOpenDlg();

	void resizeDialog(UINT nType, int cx, int cy);
	int selectFile(CString &fileName);
	void setPreviousDir(CString &dirDame);
	CString getPreviousDir();

	CString GetFileName() { return m_strPath; }
	CString GetFileTitle() { return m_strFile; }
	CString GetPathName() { return m_strPath + m_strFile; }

// Dialog Data
    enum { IDD = IDD_FILE_OPEN };

	CEdit         m_editFilename;
	CStatic       m_filetypeGroupBox;
	CComboBox     m_filetypeCombo;
	CTreeViewCtrl m_treeFolder;
	CListViewCtrl m_listFile;

	BEGIN_UPDATE_UI_MAP(CFileOpenDlg)
	END_UPDATE_UI_MAP()

// Implementation
protected:
	HWND m_hWndCECommandBar;
	CToolBarCtrl m_toolbar;

	void initVars(BOOL bOpenFileDialog, LPCTSTR lpszDefExt, LPCTSTR lpszFileName, DWORD dwFlags, LPCTSTR lpszFilter);
	BOOL			m_openFileFlag;
	CImageList		m_imlHeader,
					m_imlSystem;		//!< The system image list
	CString		m_strPath,
					m_strFile,
					m_strFilter,
					m_strDateFormat;
	RECT			m_rcTree,
					m_rcList;
	ViewState		m_nState;			// Dialog state.
#if (defined(_AYGSHELL_H_) || defined(__AYGSHELL_H__))
	CMenuBarCtrl m_pCmdBar;
#else
	CCECommandBarCtrl m_pCmdBar;			//!< The command bar.
#endif
	BOOL			m_bOk;				//!< OK button enabled?
	CFileInfoCont	m_cont;
	int				m_nSort;

	int				m_nFilterCount;		// How many filters available?
	int				m_nFilterIndex;		// Which entry on the filter list is selected?
	CString		m_FileName;			// Starting file name
	CString*	m_FilterTitles;		// List of filter descriptions
	CString*	m_FilterStrings;	// Actual filters for use in enumerating files
	int				m_dwFlags;			// Flags
	CString		m_FileExt;			// Default extension for files if none typed

	//
	// Splitter stuff
	//
	BOOL			m_bTracking;
	int				m_yTrackDel,
					m_ySplit,			//!< The tracking position
					m_yTrack;

	//
	// Enumeration methods
	//
	int EnumDirs(LPCTSTR pszPath, LPCTSTR pszFilter, HTREEITEM hItemParent);
	void EnumFiles(LPCTSTR pszPath, LPCTSTR pszFilter);

	CString GetFullPath(HTREEITEM hItem);
	CString FormatSize(DWORD dwSize);

	CString GetSystemName();
	
	int GetIconIndex(LPCTSTR pszFileName);

	void UpdateControls();

	void DoSortList();
	void SetColumnIcons();

	void DoPaint(CPaintDC& dc);

	BEGIN_MSG_MAP(CFileOpenDlg)
		COMMAND_ID_HANDLER(ID_VIEW_STANDARD, OnViewStandard)
		COMMAND_ID_HANDLER(ID_VIEW_TREE, OnViewTree)
		COMMAND_ID_HANDLER(ID_VIEW_LIST, OnViewList)
		COMMAND_ID_HANDLER(IDOK, OnBarOk)
		COMMAND_ID_HANDLER(IDCANCEL, OnBarCancel)
		COMMAND_HANDLER(IDC_EDIT_FILENAME, EN_UPDATE, OnUpdateEditFilename)
		COMMAND_HANDLER(IDC_FILETYPE_COMBO, CBN_SELCHANGE, OnSelchangeFiletypeCombo)

		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
		MESSAGE_HANDLER(WM_SIZE, OnSize)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		MESSAGE_HANDLER(WM_LBUTTONDOWN, OnLButtonDown)
		MESSAGE_HANDLER(WM_LBUTTONUP, OnLButtonUp)
		MESSAGE_HANDLER(WM_MOUSEMOVE, OnMouseMove)

		NOTIFY_HANDLER(IDC_FOLDER_TREE, TVN_SELCHANGED, OnSelchangedFolderTree)
		NOTIFY_HANDLER(IDC_FOLDER_TREE, TVN_ITEMEXPANDING, OnItemExpandingFolderTree)
		NOTIFY_HANDLER(IDC_FOLDER_TREE, TVN_GETDISPINFO, OnGetDispInfoFolderTree)
		NOTIFY_HANDLER(IDC_FILE_LIST, NM_CLICK, OnClickFileList)
		NOTIFY_HANDLER(IDC_FILE_LIST, NM_DBLCLK, OnDblclkFileList)
		NOTIFY_HANDLER(IDC_FILE_LIST, NM_CUSTOMDRAW, OnCustomDrawList)
		NOTIFY_HANDLER(0, HDN_ITEMCLICK, OnHeaderClickFileList)
	END_MSG_MAP()

// Handler prototypes (uncomment arguments if needed):
//	LRESULT MessageHandler(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
//	LRESULT CommandHandler(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
//	LRESULT NotifyHandler(int /*idCtrl*/, LPNMHDR /*pnmh*/, BOOL& /*bHandled*/);

    // Messages
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnMouseMove(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	// Commands
	LRESULT OnViewStandard(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnViewTree(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnViewList(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBarOk(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnBarCancel(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnUpdateEditFilename(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	LRESULT OnSelchangeFiletypeCombo(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/);
	// Notifications
    LRESULT OnSelchangedFolderTree(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
    LRESULT OnItemExpandingFolderTree(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
    LRESULT OnGetDispInfoFolderTree(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
    LRESULT OnClickFileList(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
    LRESULT OnDblclkFileList(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
    LRESULT OnCustomDrawList(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
    LRESULT OnHeaderClickFileList(int /*idCtrl*/, LPNMHDR pnmh, BOOL& /*bHandled*/);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILEOPENDLG1_H__5EFDF299_B718_466B_98CC_FD9C38BC6DD5__INCLUDED_)
