// hexPageDlg.h : Declaration of the CtabPageDlg

#pragma once

#include "HexCodePanel.h"
#include "HexWordEdit.h"

// ChexPageDlg

class ChexPageDlg : public CDialogImpl<ChexPageDlg>
{
public:
	enum { IDD = IDD_HEXPAGEDLG };

	CStatic m_codeBox;
	CStatic m_dataBox;
	CStatic m_configBox;

	CEdit m_dasmPanel;
	CHexCodePanel m_hexPanel;
	CEdit m_dataPanel;
	CBrush m_codeEditBrush;
	CHexWordEdit m_configWords[8];
	CHexWordEdit m_userID[4];
	CHexWordEdit m_deviceID[2];
	int sizeConfigBoxes(int width, int height, int charHeight, int innerPadding);

	bool m_showAsm;
	bool m_inHighRes;

	void SetCtrlFont(CFont &font);

BEGIN_MSG_MAP(ChexPageDlg)
	MESSAGE_HANDLER(WM_INITDIALOG, OnInitDialog)
	MESSAGE_HANDLER(WM_CTLCOLOREDIT, OnCtlColorEdit)
	MESSAGE_HANDLER(WM_CTLCOLORSTATIC, OnCtlColorStatic)
	MESSAGE_HANDLER(WM_SIZE, OnSize)
END_MSG_MAP()

// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
LRESULT OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
LRESULT OnCtlColorEdit(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
LRESULT OnCtlColorStatic(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
LRESULT OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
};


