#pragma once
#include "PIC/PICProgram.h"
#include "PIC/PICHexFile.h"

class PIC12F6XXProgram :
	public PICProgram
{
public:
	// Get the singleton instance of this class of PIC programming code
	static const PICProgram *PIC12F6XXProgram::GetDriver();

	virtual int Read(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	virtual int PartialRead(CIOPort *port, PICHexFile *hexFile, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;
	virtual int Program(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	virtual int PartialProgram(CIOPort *port, PICHexFile *hexFile, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;
	virtual int Erase(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	virtual int PartialErase(CIOPort *port, PICHexFile *hexFile, bool bootFlag = false, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;
	virtual int Verify(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
private:
	static PIC12F6XXProgram m_Driver;

	virtual int ReadCode(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	virtual int ReadConfig(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	virtual int ReadData(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;

	virtual int WriteCode(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	virtual int WriteData(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	virtual int WriteConfig(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	virtual int WriteUser(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
};
