#pragma once
#include "PIC/PIC16F/PIC12F6XXProgram.h"
#include "PIC/PICHexFile.h"

class PIC16F88Program :
	public PIC12F6XXProgram
{
public:
	// Get the singleton instance of this class of PIC programming code
	static const PICProgram *GetDriver();

	int Program(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	int PartialProgram(CIOPort *port, PICHexFile *hexFile, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;
	int Erase(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF = NULL) const;
	int PartialErase(CIOPort *port, PICHexFile *hexFile, bool bootFlag = false, bool codeFlag = false, bool dataFlag = false, bool configFlag = false, CProgrammerProgressIF *statusIF = NULL) const;
private:
	static PIC16F88Program m_Driver;

	int WriteCode(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	int WriteData(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
	int WriteConfig(const PICDevice *device, CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const;
};
