//
// Programming routines for: PIC18F2XX0/2X21/2XX5/4XX0/4X21/4XX5
//
#include "StdAfx.h"
#include <assert.h>
#include "PIC18FXX5XProgram.h"

PIC18FXX5XProgram PIC18FXX5XProgram::m_Driver;

// Get the singleton programmer instance for this class of chips
const PICProgram *PIC18FXX5XProgram::GetDriver()
{
	return &m_Driver;
}

int PIC18FXX5XProgram::Erase(CIOPort *port, PICHexFile *hexFile, CProgrammerProgressIF *statusIF) const
{
	int res = EraseCmd(port, hexFile, 0x0F87); // Erase chip

	return res;
}

int PIC18FXX5XProgram::PartialErase(CIOPort *port, PICHexFile *hexFile, bool bootFlag, bool codeFlag, bool dataFlag, bool configFlag, CProgrammerProgressIF *statusIF) const
{
	int i = 0;

	if (configFlag)
	{
		i +=  EraseCmd(port, hexFile, 0x0082); // Erase config bits
	}
	if (bootFlag)
	{
		i +=  EraseCmd(port, hexFile, 0x0081); // Erase boot block
	}
	if (codeFlag)
	{
		i +=  EraseCmd(port, hexFile, 0x0081); // Erase boot block
		i +=  EraseCmd(port, hexFile, 0x0180); // Erase panel 1
		i +=  EraseCmd(port, hexFile, 0x0280); // Erase panel 2
		i +=  EraseCmd(port, hexFile, 0x0480); // Erase panel 3
		i +=  EraseCmd(port, hexFile, 0x0880); // Erase panel 4
	}
	if (dataFlag)
	{
		i +=  EraseCmd(port, hexFile, 0x0084);
	}

	return i;
}
