#include "StdAfx.h"
#include "ProgramSelector.h"
#include "dsPIC30F/dsPIC30FXXXProgram.h"
#include "PIC16F/PIC12F6XXProgram.h"
#include "PIC16F/PIC16F84AProgram.h"
#include "PIC16F/PIC16F88Program.h"
#include "PIC16F/PIC16F7X7Program.h"
#include "PIC18F/PIC18FXXXProgram.h"
#include "PIC18F/PIC18FXX5XProgram.h"
#include "PIC18F/PIC18FXX31Program.h"

const PICProgram *ProgramSelector::GetProgrammer(const PICDevice *device)
{
	const TCHAR *devName = device->name[2];
#if 0
	if (!_tcsicmp(devName, _T("pic12f683"))) return PIC12F6XXProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f684"))) return PIC12F6XXProgram::GetDriver();
#endif
	if (!_tcsicmp(devName, _T("pic16f73"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f737"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f74"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f747"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f76"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f767"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f77"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f777"))) return PIC16F7X7Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f84A"))) return PIC16F84AProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic16f88"))) return PIC16F88Program::GetDriver();
#if 0
	if (!_tcsicmp(devName, _T("pic18f1220"))) return PIC18FXXXProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f1320"))) return PIC18FXXXProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f242"))) return PIC18FXXXProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f248"))) return PIC18FXXXProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f252"))) return PIC18FXXXProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f258"))) return PIC18FXXXProgram::GetDriver();
#endif
	if (!_tcsicmp(devName, _T("pic18f2331"))) return PIC18FXX31Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f2431"))) return PIC18FXX31Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f4331"))) return PIC18FXX31Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f4431"))) return PIC18FXX31Program::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f2455"))) return PIC18FXX5XProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f2550"))) return PIC18FXX5XProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f2585"))) return PIC18FXX5XProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f4455"))) return PIC18FXX5XProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f4550"))) return PIC18FXX5XProgram::GetDriver();
	if (!_tcsicmp(devName, _T("pic18f4620"))) return PIC18FXX5XProgram::GetDriver();

	// Default - generic erase/read/write routines for the various
	// families of PIC devices.  Most chips can use these, the ones above
	// require some modification to the default programming.
	if (device->wordSize == 14)
		return PIC12F6XXProgram::GetDriver();
	else if (device->wordSize == 16)
		return PIC18FXXXProgram::GetDriver();
	else if (device->wordSize == 24)
		return dsPIC30FXXXProgram::GetDriver();
	else
		// Unknown PIC word size...
		return PIC12F6XXProgram::GetDriver();

}
