#include "IOPort.h"

CIOPort::CIOPort(void)
{
}

CIOPort::~CIOPort(void)
{
}

int CIOPort::Close()
{
	// TBD: close serial port
	if (m_Serial.IsOpen())
		return m_Serial.Close();
	else if (m_USB.IsOpen())
		return m_USB.Close();

	return -1;
}

void CIOPort::Flush()
{
	if (m_Serial.IsOpen())
		m_Serial.Flush();
	else
		m_USB.Flush();
}

void CIOPort::Purge()
{
	if (m_Serial.IsOpen())
		m_Serial.Purge();
	else
		m_USB.Flush();
}

bool CIOPort::IsOpen()
{
	return m_Serial.IsOpen() | m_USB.IsOpen();
}

bool CIOPort::Open(LPCTSTR portName, int baudRate)
{
	bool result = false;

	// Ensure any open device is closed
	Close();

	// See if user wants a USB connection or a serial connection to
	// the programmer.
	if (!_tcscmp(portName, _T("USB:")))
	{
		// Attempt to open USB device
		DWORD DEFAULT_VID = 0x04D8;
		DWORD DEFAULT_PID = 0xFF39;
		result = m_USB.Connect(DEFAULT_VID, DEFAULT_PID);
	}
	else
	{
		// Attempt to open serial port
		result = SUCCEEDED(m_Serial.Open(portName, baudRate, NOPARITY, ONESTOPBIT, true));
		// result = SUCCEEDED(m_Serial.Open(portName, baudRate, NOPARITY, ONESTOPBIT, false));
	}

	return result;
}